Index: serefpolicy-contrib-20140730/rpm.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rpm.te
+++ serefpolicy-contrib-20140730/rpm.te
@@ -1,15 +1,13 @@
 policy_module(rpm, 1.16.0)
 
+attribute rpm_transition_domain;
+attribute_role rpm_script_roles;
+roleattribute system_r rpm_script_roles;
+
 ########################################
 #
 # Declarations
 #
-
-attribute_role rpm_roles;
-
-type debuginfo_exec_t;
-domain_entry_file(rpm_t, debuginfo_exec_t)
-
 type rpm_t;
 type rpm_exec_t;
 init_system_domain(rpm_t, rpm_exec_t)
@@ -17,10 +15,10 @@ domain_obj_id_change_exemption(rpm_t)
 domain_role_change_exemption(rpm_t)
 domain_system_change_exemption(rpm_t)
 domain_interactive_fd(rpm_t)
-role rpm_roles types rpm_t;
+role rpm_script_roles types rpm_t;
 
-type rpm_initrc_exec_t;
-init_script_file(rpm_initrc_exec_t)
+type debuginfo_exec_t;
+domain_entry_file(rpm_t, debuginfo_exec_t)
 
 type rpm_file_t;
 files_type(rpm_file_t)
@@ -31,9 +29,6 @@ files_tmp_file(rpm_tmp_t)
 type rpm_tmpfs_t;
 files_tmpfs_file(rpm_tmpfs_t)
 
-type rpm_lock_t;
-files_lock_file(rpm_lock_t)
-
 type rpm_log_t;
 logging_log_file(rpm_log_t)
 
@@ -56,8 +51,7 @@ corecmd_bin_entry_type(rpm_script_t)
 domain_type(rpm_script_t)
 domain_entry_file(rpm_t, rpm_script_exec_t)
 domain_interactive_fd(rpm_script_t)
-role rpm_roles types rpm_script_t;
-role system_r types rpm_script_t;
+role rpm_script_roles types rpm_script_t;
 
 type rpm_script_tmp_t;
 files_tmp_file(rpm_script_tmp_t)
@@ -70,28 +64,34 @@ files_tmpfs_file(rpm_script_tmpfs_t)
 # rpm Local policy
 #
 
+allow rpm_t self:capability2 block_suspend;
 allow rpm_t self:capability { chown dac_override fowner setfcap fsetid ipc_lock setgid setuid sys_chroot sys_nice sys_tty_config mknod };
 allow rpm_t self:process ~{ ptrace setcurrent setexec setfscreate setrlimit execstack execheap };
 allow rpm_t self:process { getattr setexec setfscreate setrlimit };
 allow rpm_t self:fd use;
 allow rpm_t self:fifo_file rw_fifo_file_perms;
+allow rpm_t self:unix_dgram_socket create_socket_perms;
+allow rpm_t self:unix_stream_socket rw_stream_socket_perms;
 allow rpm_t self:unix_dgram_socket sendto;
-allow rpm_t self:unix_stream_socket { accept connectto listen };
-allow rpm_t self:udp_socket connect;
-allow rpm_t self:tcp_socket { accept listen };
+allow rpm_t self:unix_stream_socket connectto;
+allow rpm_t self:udp_socket { connect };
+allow rpm_t self:udp_socket create_socket_perms;
+allow rpm_t self:tcp_socket create_stream_socket_perms;
 allow rpm_t self:shm create_shm_perms;
 allow rpm_t self:sem create_sem_perms;
 allow rpm_t self:msgq create_msgq_perms;
 allow rpm_t self:msg { send receive };
-allow rpm_t self:file rw_file_perms;
+allow rpm_t self:dir search;
+allow rpm_t self:file rw_file_perms;;
 allow rpm_t self:netlink_kobject_uevent_socket create_socket_perms;
 
-allow rpm_t rpm_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+allow rpm_t rpm_log_t:file manage_file_perms;
 logging_log_filetrans(rpm_t, rpm_log_t, file)
 
 manage_dirs_pattern(rpm_t, rpm_tmp_t, rpm_tmp_t)
 manage_files_pattern(rpm_t, rpm_tmp_t, rpm_tmp_t)
 files_tmp_filetrans(rpm_t, rpm_tmp_t, { file dir })
+can_exec(rpm_t, rpm_tmp_t)
 
 manage_dirs_pattern(rpm_t, rpm_tmpfs_t, rpm_tmpfs_t)
 manage_files_pattern(rpm_t, rpm_tmpfs_t, rpm_tmpfs_t)
@@ -99,23 +99,19 @@ manage_lnk_files_pattern(rpm_t, rpm_tmpf
 manage_fifo_files_pattern(rpm_t, rpm_tmpfs_t, rpm_tmpfs_t)
 manage_sock_files_pattern(rpm_t, rpm_tmpfs_t, rpm_tmpfs_t)
 fs_tmpfs_filetrans(rpm_t, rpm_tmpfs_t, { dir file lnk_file sock_file fifo_file })
+can_exec(rpm_t, rpm_tmpfs_t)
 
 manage_dirs_pattern(rpm_t, rpm_var_cache_t, rpm_var_cache_t)
 manage_files_pattern(rpm_t, rpm_var_cache_t, rpm_var_cache_t)
 files_var_filetrans(rpm_t, rpm_var_cache_t, dir)
 
-manage_files_pattern(rpm_t, rpm_lock_t, rpm_lock_t)
-files_lock_filetrans(rpm_t, rpm_lock_t, file)
-
-manage_dirs_pattern(rpm_t, rpm_var_lib_t, rpm_var_lib_t)
+# Access /var/lib/rpm files
 manage_files_pattern(rpm_t, rpm_var_lib_t, rpm_var_lib_t)
-files_var_lib_filetrans(rpm_t, rpm_var_lib_t, { dir file })
+files_var_lib_filetrans(rpm_t, rpm_var_lib_t, dir)
 
 manage_dirs_pattern(rpm_t, rpm_var_run_t, rpm_var_run_t)
 manage_files_pattern(rpm_t, rpm_var_run_t, rpm_var_run_t)
-files_pid_filetrans(rpm_t, rpm_var_run_t, { dir file })
-
-can_exec(rpm_t, { rpm_tmp_t rpm_tmpfs_t })
+files_pid_filetrans(rpm_t, rpm_var_run_t, { file dir })
 
 kernel_read_crypto_sysctls(rpm_t)
 kernel_read_network_state(rpm_t)
@@ -126,41 +122,34 @@ kernel_rw_irq_sysctls(rpm_t)
 
 corecmd_exec_all_executables(rpm_t)
 
-corenet_all_recvfrom_unlabeled(rpm_t)
 corenet_all_recvfrom_netlabel(rpm_t)
 corenet_tcp_sendrecv_generic_if(rpm_t)
+corenet_raw_sendrecv_generic_if(rpm_t)
+corenet_udp_sendrecv_generic_if(rpm_t)
 corenet_tcp_sendrecv_generic_node(rpm_t)
+corenet_raw_sendrecv_generic_node(rpm_t)
+corenet_udp_sendrecv_generic_node(rpm_t)
 corenet_tcp_sendrecv_all_ports(rpm_t)
-
-corenet_sendrecv_all_client_packets(rpm_t)
+corenet_udp_sendrecv_all_ports(rpm_t)
 corenet_tcp_connect_all_ports(rpm_t)
+corenet_sendrecv_all_client_packets(rpm_t)
 
 dev_list_sysfs(rpm_t)
 dev_list_usbfs(rpm_t)
 dev_read_urand(rpm_t)
 dev_read_raw_memory(rpm_t)
-
 dev_manage_all_dev_nodes(rpm_t)
-dev_relabel_all_dev_nodes(rpm_t)
 
+#devices_manage_all_device_types(rpm_t)
 dev_create_generic_blk_files(rpm_t)
 dev_create_generic_chr_files(rpm_t)
-
-domain_read_all_domains_state(rpm_t)
-domain_getattr_all_domains(rpm_t)
-domain_use_interactive_fds(rpm_t)
-domain_dontaudit_getattr_all_pipes(rpm_t)
-domain_dontaudit_getattr_all_tcp_sockets(rpm_t)
-domain_dontaudit_getattr_all_udp_sockets(rpm_t)
-domain_dontaudit_getattr_all_packet_sockets(rpm_t)
-domain_dontaudit_getattr_all_raw_sockets(rpm_t)
-domain_dontaudit_getattr_all_stream_sockets(rpm_t)
-domain_dontaudit_getattr_all_dgram_sockets(rpm_t)
-domain_signull_all_domains(rpm_t)
-
-files_exec_etc_files(rpm_t)
-files_relabel_non_auth_files(rpm_t)
-files_manage_non_auth_files(rpm_t)
+dev_delete_all_blk_files(rpm_t)
+dev_delete_all_chr_files(rpm_t)
+dev_relabel_all_dev_nodes(rpm_t)
+dev_rename_generic_blk_files(rpm_t)
+dev_rename_generic_chr_files(rpm_t)
+dev_setattr_all_blk_files(rpm_t)
+dev_setattr_all_chr_files(rpm_t)
 
 fs_getattr_all_dirs(rpm_t)
 fs_list_inotifyfs(rpm_t)
@@ -183,29 +172,49 @@ selinux_compute_relabel_context(rpm_t)
 selinux_compute_user_contexts(rpm_t)
 
 storage_raw_write_fixed_disk(rpm_t)
+# for installing kernel packages
 storage_raw_read_fixed_disk(rpm_t)
 
 term_list_ptys(rpm_t)
 
+files_relabel_all_files(rpm_t)
+files_manage_all_files(rpm_t)
 auth_dontaudit_read_shadow(rpm_t)
 auth_use_nsswitch(rpm_t)
 
+# transition to rpm script:
 rpm_domtrans_script(rpm_t)
 
+domain_read_all_domains_state(rpm_t)
+domain_getattr_all_domains(rpm_t)
+domain_use_interactive_fds(rpm_t)
+domain_dontaudit_getattr_all_pipes(rpm_t)
+domain_dontaudit_getattr_all_tcp_sockets(rpm_t)
+domain_dontaudit_getattr_all_udp_sockets(rpm_t)
+domain_dontaudit_getattr_all_packet_sockets(rpm_t)
+domain_dontaudit_getattr_all_raw_sockets(rpm_t)
+domain_dontaudit_getattr_all_stream_sockets(rpm_t)
+domain_dontaudit_getattr_all_dgram_sockets(rpm_t)
+domain_signull_all_domains(rpm_t)
+
+files_exec_etc_files(rpm_t)
+
 init_domtrans_script(rpm_t)
 init_use_script_ptys(rpm_t)
 init_signull_script(rpm_t)
 
 libs_exec_ld_so(rpm_t)
 libs_exec_lib_files(rpm_t)
-libs_run_ldconfig(rpm_t, rpm_roles)
 
 logging_send_syslog_msg(rpm_t)
 
+miscfiles_filetrans_named_content(rpm_t)
+
+# allow compiling and loading new policy
 seutil_manage_src_policy(rpm_t)
 seutil_manage_bin_policy(rpm_t)
 
-userdom_use_user_terminals(rpm_t)
+userdom_use_inherited_user_terminals(rpm_t)
 userdom_use_unpriv_users_fds(rpm_t)
 
 optional_policy(`
@@ -224,13 +233,17 @@ optional_policy(`
 		networkmanager_dbus_chat(rpm_t)
 	')
 
-	optional_policy(`
-		unconfined_dbus_chat(rpm_t)
-	')
 ')
 
 optional_policy(`
-	prelink_run(rpm_t, rpm_roles)
+	prelink_domtrans(rpm_t)
+')
+
+optional_policy(`
+	unconfined_domain_noaudit(rpm_t)
+	# yum-updatesd requires this
+	unconfined_dbus_chat(rpm_t)
+	unconfined_dbus_chat(rpm_script_t)
 ')
 
 ########################################
@@ -239,18 +252,20 @@ optional_policy(`
 #
 
 allow rpm_script_t self:capability { chown dac_override dac_read_search fowner fsetid setgid setuid ipc_lock sys_admin sys_chroot sys_rawio sys_nice mknod kill net_admin };
+
 allow rpm_script_t self:process ~{ ptrace setcurrent setexec setfscreate setrlimit execheap };
 allow rpm_script_t self:fd use;
 allow rpm_script_t self:fifo_file rw_fifo_file_perms;
+allow rpm_script_t self:unix_dgram_socket create_socket_perms;
+allow rpm_script_t self:unix_stream_socket rw_stream_socket_perms;
 allow rpm_script_t self:unix_dgram_socket sendto;
-allow rpm_script_t self:unix_stream_socket { accept connectto listen };
+allow rpm_script_t self:unix_stream_socket connectto;
 allow rpm_script_t self:shm create_shm_perms;
 allow rpm_script_t self:sem create_sem_perms;
 allow rpm_script_t self:msgq create_msgq_perms;
 allow rpm_script_t self:msg { send receive };
 allow rpm_script_t self:netlink_kobject_uevent_socket create_socket_perms;
-
-allow rpm_script_t rpm_t:netlink_route_socket { read write };
+allow rpm_script_t self:netlink_audit_socket { create_socket_perms nlmsg_relay };
 
 allow rpm_script_t rpm_tmp_t:file read_file_perms;
 
@@ -267,8 +282,9 @@ manage_lnk_files_pattern(rpm_script_t, r
 manage_fifo_files_pattern(rpm_script_t, rpm_script_tmpfs_t, rpm_script_tmpfs_t)
 manage_sock_files_pattern(rpm_script_t, rpm_script_tmpfs_t, rpm_script_tmpfs_t)
 fs_tmpfs_filetrans(rpm_script_t, rpm_script_tmpfs_t, { dir file lnk_file sock_file fifo_file })
+can_exec(rpm_script_t, rpm_script_tmpfs_t)
 
-can_exec(rpm_script_t, { rpm_script_tmp_t rpm_script_tmpfs_t })
+allow rpm_script_t rpm_t:netlink_route_socket { read write };
 
 kernel_read_crypto_sysctls(rpm_script_t)
 kernel_read_kernel_sysctls(rpm_script_t)
@@ -277,45 +293,29 @@ kernel_read_network_state(rpm_script_t)
 kernel_list_all_proc(rpm_script_t)
 kernel_read_software_raid_state(rpm_script_t)
 
-corenet_all_recvfrom_unlabeled(rpm_script_t)
-corenet_all_recvfrom_netlabel(rpm_script_t)
-corenet_tcp_sendrecv_generic_if(rpm_script_t)
-corenet_tcp_sendrecv_generic_node(rpm_script_t)
-
-corenet_sendrecv_http_client_packets(rpm_script_t)
+# needed by rhn_check
 corenet_tcp_connect_http_port(rpm_script_t)
-corenet_tcp_sendrecv_http_port(rpm_script_t)
-
-corecmd_exec_all_executables(rpm_script_t)
+# needed by unbound-anchor
+corenet_udp_bind_all_unreserved_ports(rpm_script_t)
 
 dev_list_sysfs(rpm_script_t)
+
+# ideally we would not need this
 dev_manage_generic_blk_files(rpm_script_t)
 dev_manage_generic_chr_files(rpm_script_t)
 dev_manage_all_blk_files(rpm_script_t)
 dev_manage_all_chr_files(rpm_script_t)
 
-domain_read_all_domains_state(rpm_script_t)
-domain_getattr_all_domains(rpm_script_t)
-domain_use_interactive_fds(rpm_script_t)
-domain_signal_all_domains(rpm_script_t)
-domain_signull_all_domains(rpm_script_t)
-
-files_exec_etc_files(rpm_script_t)
-files_exec_usr_files(rpm_script_t)
-files_manage_non_auth_files(rpm_script_t)
-files_relabel_non_auth_files(rpm_script_t)
-
 fs_manage_nfs_files(rpm_script_t)
 fs_getattr_nfs(rpm_script_t)
 fs_search_all(rpm_script_t)
 fs_getattr_all_fs(rpm_script_t)
+# why is this not using mount?
 fs_getattr_xattr_fs(rpm_script_t)
 fs_mount_xattr_fs(rpm_script_t)
 fs_unmount_xattr_fs(rpm_script_t)
 fs_search_auto_mountpoints(rpm_script_t)
 
-mcs_killall(rpm_script_t)
-
 mls_file_read_all_levels(rpm_script_t)
 mls_file_write_all_levels(rpm_script_t)
 
@@ -331,30 +331,52 @@ storage_raw_write_fixed_disk(rpm_script_
 
 term_getattr_unallocated_ttys(rpm_script_t)
 term_list_ptys(rpm_script_t)
-term_use_all_terms(rpm_script_t)
+term_use_all_inherited_terms(rpm_script_t)
 
 auth_dontaudit_getattr_shadow(rpm_script_t)
 auth_use_nsswitch(rpm_script_t)
 
+corecmd_exec_all_executables(rpm_script_t)
+can_exec(rpm_script_t, rpm_script_tmp_t)
+can_exec(rpm_script_t, rpm_script_tmpfs_t)
+
+domain_read_all_domains_state(rpm_script_t)
+domain_getattr_all_domains(rpm_script_t)
+domain_use_interactive_fds(rpm_script_t)
+domain_signal_all_domains(rpm_script_t)
+domain_signull_all_domains(rpm_script_t)
+
+# ideally we would not need this
+files_manage_all_files(rpm_script_t)
+files_exec_etc_files(rpm_script_t)
+files_read_etc_runtime_files(rpm_script_t)
+files_exec_usr_files(rpm_script_t)
+files_relabel_all_files(rpm_script_t)
+
+init_disable_services(rpm_script_t)
+init_enable_services(rpm_script_t)
+init_reload_services(rpm_script_t)
 init_domtrans_script(rpm_script_t)
 init_telinit(rpm_script_t)
 
+systemd_config_all_services(rpm_script_t)
+
 libs_exec_ld_so(rpm_script_t)
 libs_exec_lib_files(rpm_script_t)
-libs_run_ldconfig(rpm_script_t, rpm_roles)
+libs_ldconfig_exec_entry_type(rpm_script_t)
 
 logging_send_syslog_msg(rpm_script_t)
+logging_send_audit_msgs(rpm_script_t)
 
-miscfiles_read_localization(rpm_script_t)
+miscfiles_filetrans_named_content(rpm_script_t)
 
-modutils_run_depmod(rpm_script_t, rpm_roles)
-modutils_run_insmod(rpm_script_t, rpm_roles)
-
-seutil_run_loadpolicy(rpm_script_t, rpm_roles)
-seutil_run_setfiles(rpm_script_t, rpm_roles)
-seutil_run_semanage(rpm_script_t, rpm_roles)
+seutil_run_loadpolicy(rpm_script_t, rpm_script_roles)
+seutil_run_setfiles(rpm_script_t, rpm_script_roles)
+seutil_run_semanage(rpm_script_t, rpm_script_roles)
+seutil_run_setsebool(rpm_script_t, rpm_script_roles)
 
 userdom_use_all_users_fds(rpm_script_t)
+userdom_exec_admin_home_files(rpm_script_t)
 
 ifdef(`distro_redhat',`
 	optional_policy(`
@@ -363,41 +385,69 @@ ifdef(`distro_redhat',`
 	')
 ')
 
-tunable_policy(`allow_execmem',`
+tunable_policy(`deny_execmem',`',`
 	allow rpm_script_t self:process execmem;
 ')
 
 optional_policy(`
-	bootloader_run(rpm_script_t, rpm_roles)
+	bootloader_run(rpm_script_t, rpm_script_roles)
+')
+
+optional_policy(`
+    bind_systemctl(rpm_script_t)
+')
+
+optional_policy(`
+	certmonger_dbus_chat(rpm_script_t)
+')
+
+optional_policy(`
+	cups_filetrans_named_content(rpm_script_t)
+')
+
+optional_policy(`
+    sblim_filetrans_named_content(rpm_script_t)
 ')
 
 optional_policy(`
 	dbus_system_bus_client(rpm_script_t)
 
-	optional_policy(`
-		unconfined_dbus_chat(rpm_script_t)
-	')
+    optional_policy(`
+        systemd_dbus_chat_logind(rpm_script_t)
+        systemd_dbus_chat_timedated(rpm_script_t)
+        systemd_dbus_chat_localed(rpm_script_t)
+    ')
+')
+
+optional_policy(`
+	lvm_domtrans(rpm_script_t, rpm_script_roles)
+')
+
+optional_policy(`
+	ntp_run(rpm_script_t, rpm_script_roles)
 ')
 
 optional_policy(`
-	lvm_run(rpm_script_t, rpm_roles)
+	modutils_run_depmod(rpm_script_t, rpm_script_roles)
+	modutils_run_insmod(rpm_script_t, rpm_script_roles)
 ')
 
 optional_policy(`
-	ntp_domtrans(rpm_script_t)
+	openshift_initrc_run(rpm_script_t, rpm_script_roles)
 ')
 
 optional_policy(`
-	tzdata_run(rpm_t, rpm_roles)
-	tzdata_run(rpm_script_t, rpm_roles)
+	tzdata_domtrans(rpm_t)
+	tzdata_run(rpm_script_t, rpm_script_roles)
 ')
 
 optional_policy(`
-	udev_domtrans(rpm_script_t)
+	udev_run(rpm_script_t, rpm_script_roles)
 ')
 
 optional_policy(`
-	unconfined_domtrans(rpm_script_t)
+	unconfined_domain_noaudit(rpm_script_t)
+	domain_named_filetrans(rpm_script_t)
 
 	optional_policy(`
 		java_domtrans_unconfined(rpm_script_t)
@@ -409,6 +459,6 @@ optional_policy(`
 ')
 
 optional_policy(`
-	usermanage_run_groupadd(rpm_script_t, rpm_roles)
-	usermanage_run_useradd(rpm_script_t, rpm_roles)
+	usermanage_run_groupadd(rpm_script_t, rpm_script_roles)
+	usermanage_run_useradd(rpm_script_t, rpm_script_roles)
 ')
Index: serefpolicy-contrib-20140730/rshd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rshd.if
+++ serefpolicy-contrib-20140730/rshd.if
@@ -2,7 +2,7 @@
 
 ########################################
 ## <summary>
-##	Execute rshd in the rshd domain.
+##	Domain transition to rshd.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -15,6 +15,7 @@ interface(`rshd_domtrans',`
 		type rshd_exec_t, rshd_t;
 	')
 
+	files_search_usr($1)
 	corecmd_search_bin($1)
 	domtrans_pattern($1, rshd_exec_t, rshd_t)
 ')
Index: serefpolicy-contrib-20140730/rshd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rshd.te
+++ serefpolicy-contrib-20140730/rshd.te
@@ -1,14 +1,15 @@
-policy_module(rshd, 1.9.0)
+policy_module(rshd, 1.8.1)
 
 ########################################
 #
 # Declarations
 #
-
 type rshd_t;
 type rshd_exec_t;
-auth_login_pgm_domain(rshd_t)
 inetd_tcp_service_domain(rshd_t, rshd_exec_t)
+domain_subj_id_change_exemption(rshd_t)
+domain_role_change_exemption(rshd_t)
+role system_r types rshd_t;
 
 type rshd_keytab_t;
 files_type(rshd_keytab_t)
@@ -17,9 +18,8 @@ files_type(rshd_keytab_t)
 #
 # Local policy
 #
-
 allow rshd_t self:capability { kill setuid setgid fowner fsetid chown dac_override };
-allow rshd_t self:process { signal_perms setsched setpgid setexec };
+allow rshd_t self:process { signal_perms fork setsched setpgid setexec };
 allow rshd_t self:fifo_file rw_fifo_file_perms;
 allow rshd_t self:tcp_socket create_stream_socket_perms;
 
@@ -27,41 +27,56 @@ allow rshd_t rshd_keytab_t:file read_fil
 
 kernel_read_kernel_sysctls(rshd_t)
 
-corenet_all_recvfrom_unlabeled(rshd_t)
 corenet_all_recvfrom_netlabel(rshd_t)
 corenet_tcp_sendrecv_generic_if(rshd_t)
+corenet_udp_sendrecv_generic_if(rshd_t)
 corenet_tcp_sendrecv_generic_node(rshd_t)
+corenet_udp_sendrecv_generic_node(rshd_t)
 corenet_tcp_sendrecv_all_ports(rshd_t)
+corenet_udp_sendrecv_all_ports(rshd_t)
 corenet_tcp_bind_generic_node(rshd_t)
-
-corenet_sendrecv_all_server_packets(rshd_t)
 corenet_tcp_bind_rsh_port(rshd_t)
 corenet_tcp_bind_all_rpc_ports(rshd_t)
 corenet_tcp_connect_all_ports(rshd_t)
 corenet_tcp_connect_all_rpc_ports(rshd_t)
+corenet_sendrecv_rsh_server_packets(rshd_t)
+
+dev_read_urand(rshd_t)
+
+domain_interactive_fd(rshd_t)
+
+selinux_get_fs_mount(rshd_t)
+selinux_validate_context(rshd_t)
+selinux_compute_access_vector(rshd_t)
+selinux_compute_create_context(rshd_t)
+selinux_compute_relabel_context(rshd_t)
+selinux_compute_user_contexts(rshd_t)
 
 corecmd_read_bin_symlinks(rshd_t)
 
 files_list_home(rshd_t)
+files_search_tmp(rshd_t)
+
+auth_login_pgm_domain(rshd_t)
+auth_write_login_records(rshd_t)
 
+init_rw_utmp(rshd_t)
+
+logging_send_syslog_msg(rshd_t)
 logging_search_logs(rshd_t)
 
-miscfiles_read_localization(rshd_t)
+seutil_read_config(rshd_t)
+seutil_read_default_contexts(rshd_t)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_read_nfs_files(rshd_t)
-	fs_read_nfs_symlinks(rshd_t)
-')
+userdom_search_user_home_content(rshd_t)
+userdom_manage_tmp_role(system_r, rshd_t)
 
-tunable_policy(`use_samba_home_dirs',`
-	fs_read_cifs_files(rshd_t)
-	fs_read_cifs_symlinks(rshd_t)
-')
+userdom_home_reader(rshd_t)
 
 optional_policy(`
 	kerberos_manage_host_rcache(rshd_t)
 	kerberos_read_keytab(rshd_t)
-	kerberos_tmp_filetrans_host_rcache(rshd_t, file, "host_0")
+	kerberos_tmp_filetrans_host_rcache(rshd_t, "host_0")
 	kerberos_use(rshd_t)
 ')
 
Index: serefpolicy-contrib-20140730/rssh.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rssh.te
+++ serefpolicy-contrib-20140730/rssh.te
@@ -60,18 +60,14 @@ manage_files_pattern(rssh_t, rssh_rw_t,
 kernel_read_system_state(rssh_t)
 kernel_read_kernel_sysctls(rssh_t)
 
-files_read_etc_files(rssh_t)
 files_read_etc_runtime_files(rssh_t)
 files_list_home(rssh_t)
-files_read_usr_files(rssh_t)
 files_list_var(rssh_t)
 
 fs_search_auto_mountpoints(rssh_t)
 
 logging_send_syslog_msg(rssh_t)
 
-miscfiles_read_localization(rssh_t)
-
 rssh_domtrans_chroot_helper(rssh_t)
 
 ssh_rw_tcp_sockets(rssh_t)
@@ -95,5 +91,3 @@ domain_use_interactive_fds(rssh_chroot_h
 auth_use_nsswitch(rssh_chroot_helper_t)
 
 logging_send_syslog_msg(rssh_chroot_helper_t)
-
-miscfiles_read_localization(rssh_chroot_helper_t)
Index: serefpolicy-contrib-20140730/rsync.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/rsync.fc
+++ serefpolicy-contrib-20140730/rsync.fc
@@ -1,7 +1,8 @@
 /etc/rsyncd\.conf	--	gen_context(system_u:object_r:rsync_etc_t, s0)
 
-/usr/bin/rsync	--	gen_context(system_u:object_r:rsync_exec_t,s0)
+/usr/bin/rsync		--	gen_context(system_u:object_r:rsync_exec_t,s0)
 
-/var/log/rsync\.log.*	--	gen_context(system_u:object_r:rsync_log_t,s0)
+/var/log/rsync.*		gen_context(system_u:object_r:rsync_log_t,s0)
 
 /var/run/rsyncd\.lock	--	gen_context(system_u:object_r:rsync_var_run_t,s0)
+/var/run/swift_server\.lock	--	gen_context(system_u:object_r:rsync_var_run_t,s0)
Index: serefpolicy-contrib-20140730/rsync.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rsync.if
+++ serefpolicy-contrib-20140730/rsync.if
@@ -1,16 +1,32 @@
-## <summary>Fast incremental file transfer for synchronization.</summary>
+## <summary>Fast incremental file transfer for synchronization</summary>
+
+#######################################
+## <summary>
+##      Sendmail stub interface.  No access allowed.
+## </summary>
+## <param name="domain" unused="true">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`rsync_stub',`
+    gen_require(`
+        type rsync_t;
+    ')
+')
 
 ########################################
 ## <summary>
-##	Make rsync executable file an
-##	entry point for the specified domain.
+##	Make rsync an entry point for
+##	the specified domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	The domain for which rsync_exec_t is an entrypoint.
+##	The domain for which init scripts are an entrypoint.
 ##	</summary>
 ## </param>
-#
+# cjp: added for portage
 interface(`rsync_entry_type',`
 	gen_require(`
 		type rsync_exec_t;
@@ -43,14 +59,13 @@ interface(`rsync_entry_type',`
 ##	Domain to transition to.
 ##	</summary>
 ## </param>
-#
+# cjp: added for portage
 interface(`rsync_entry_spec_domtrans',`
 	gen_require(`
 		type rsync_exec_t;
 	')
 
-	corecmd_search_bin($1)
-	auto_trans($1, rsync_exec_t, $2)
+	domain_trans($1, rsync_exec_t, $2)
 ')
 
 ########################################
@@ -77,82 +92,56 @@ interface(`rsync_entry_spec_domtrans',`
 ##	Domain to transition to.
 ##	</summary>
 ## </param>
-#
+# cjp: added for portage
 interface(`rsync_entry_domtrans',`
 	gen_require(`
 		type rsync_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domain_auto_trans($1, rsync_exec_t, $2)
 ')
 
 ########################################
 ## <summary>
-##	Execute the rsync program in the rsync domain.
+##	Execute rsync in the caller domain domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
-interface(`rsync_domtrans',`
+interface(`rsync_exec',`
 	gen_require(`
-		type rsync_t, rsync_exec_t;
+		type rsync_exec_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, rsync_exec_t, rsync_t)
+	can_exec($1, rsync_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute rsync in the rsync domain, and
-##	allow the specified role the rsync domain.
+##	Read rsync config files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-#
-interface(`rsync_run',`
-	gen_require(`
-		attribute_role rsync_roles;
-	')
-
-	rsync_domtrans($1)
-	roleattribute $2 rsync_roles;
-')
-
-########################################
 ## <summary>
-##	Execute rsync in the caller domain.
-## </summary>
-## <param name="domain">
-##	<summary>
 ##	Domain allowed access.
-##	</summary>
+## </summary>
 ## </param>
 #
-interface(`rsync_exec',`
+interface(`rsync_read_config',`
 	gen_require(`
-		type rsync_exec_t;
+		type rsync_etc_t;
 	')
 
-	corecmd_search_bin($1)
-	can_exec($1, rsync_exec_t)
+	read_files_pattern($1, rsync_etc_t, rsync_etc_t)
+	files_search_etc($1)
 ')
 
 ########################################
 ## <summary>
-##	Read rsync config files.
+##	Read rsync data files.
 ## </summary>
 ## <param name="domain">
 ## <summary>
@@ -160,23 +149,23 @@ interface(`rsync_exec',`
 ## </summary>
 ## </param>
 #
-interface(`rsync_read_config',`
+interface(`rsync_read_data',`
 	gen_require(`
-		type rsync_etc_t;
+		type rsync_data_t;
 	')
 
-	files_search_etc($1)
-	allow $1 rsync_etc_t:file read_file_perms;
+	read_files_pattern($1, rsync_data_t, rsync_data_t)
 ')
 
+
 ########################################
 ## <summary>
-##	Write rsync config files.
+##	Write to rsync config files.
 ## </summary>
 ## <param name="domain">
-## <summary>
+##	<summary>
 ##	Domain allowed access.
-## </summary>
+##	</summary>
 ## </param>
 #
 interface(`rsync_write_config',`
@@ -184,14 +173,13 @@ interface(`rsync_write_config',`
 		type rsync_etc_t;
 	')
 
+	write_files_pattern($1, rsync_etc_t, rsync_etc_t)
 	files_search_etc($1)
-	allow $1 rsync_etc_t:file write_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	rsync config files.
+##	Manage rsync config files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -199,18 +187,18 @@ interface(`rsync_write_config',`
 ##	</summary>
 ## </param>
 #
-interface(`rsync_manage_config_files',`
+interface(`rsync_manage_config',`
 	gen_require(`
 		type rsync_etc_t;
 	')
 
-	files_search_etc($1)
 	manage_files_pattern($1, rsync_etc_t, rsync_etc_t)
+	files_search_etc($1)
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in etc directories
+##	Create objects in etc directories
 ##	with rsync etc type.
 ## </summary>
 ## <param name="domain">
@@ -239,43 +227,21 @@ interface(`rsync_etc_filetrans_config',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an rsync environment.
+##	Transition to rsync named content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
+##      Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`rsync_admin',`
+interface(`rsync_filetrans_named_content',`
 	gen_require(`
-		type rsync_t, rsync_etc_t, rsync_data_t;
-		type rsync_log_t, rsync_tmp_t. rsync_var_run_t;
+		type rsync_etc_t;
+        type rsync_var_run_t;
 	')
 
-	allow $1 rsync_t:process { ptrace signal_perms };
-	ps_process_pattern($1, rsync_t)
-
-	files_search_etc($1)
-	admin_pattern($1, rsync_etc_t)
-
-	admin_pattern($1, rsync_data_t)
-
-	logging_search_logs($1)
-	admin_pattern($1, rsync_log_t)
-
-	files_search_tmp($1)
-	admin_pattern($1, rsync_tmp_t)
-
-	files_search_pids($1)
-	admin_pattern($1, rsync_var_run_t)
-
-	rsync_run($1, $2)
+	files_etc_filetrans($1, rsync_etc_t, file, "rsyncd.cond")
+	files_pid_filetrans($1, rsync_var_run_t, file, "swift_server.lock")
+	files_pid_filetrans($1, rsync_var_run_t, file, "rsyncd.lock")
 ')
